Bug 10467 - samba.vfstest.stream_depot test fails against Btrfs
samba.vfstest.stream_depot test fails against Btrfs
Status: RESOLVED FIXED
Product: Samba 4.1 and newer
Classification: Unclassified
Component: VFS Modules
unspecified
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2014-02-24 18:04 UTC by David Disseldorp
Modified: 2014-03-25 09:35 UTC (History)
0 users

See Also:


Attachments
fix for v4-1-test branch, cherry-picked from master (2.05 KB, patch)
2014-02-24 18:09 UTC, David Disseldorp
asn: review+
Details

Note You need to log in before you can comment on or make changes to this bug.
Description David Disseldorp 2014-02-24 18:04:52 UTC
The 4.1.x samba.vfstest.stream_depot smbtorture test currently fails against Btrfs
due to vfs_stream_depot's incorrect nlink==2 empty directory checks.

The following upstream (master) fix is required in the 4.1 code-base:
commit 654b784e9c9c3563afd1af853f4795117c258e56
Author: Andreas Schneider <asn@samba.org>
Date:   Fri Nov 8 15:41:18 2013 +0100

    s3-vfs: Fix stream_depot vfs module on btrfs.

    Checking if the directory is empty using 'nlink == 2' only checks if
    there are no subdirectories. It doesn't indicate if there are files in
    the directory. However checking link count for no subdirectories is
    wrong and applications shouldn't rely on it, see:

    https://lkml.org/lkml/2012/2/1/756

    Signed-off-by: Andreas Schneider <asn@samba.org>
    Reviewed-by: David Disseldorp <ddiss@samba.org>
Comment 1 David Disseldorp 2014-02-24 18:09:14 UTC
Created attachment 9715 [details]
fix for v4-1-test branch, cherry-picked from master
Comment 2 David Disseldorp 2014-02-25 10:19:28 UTC
Karolin, please merge for 4.1.next.
Thanks!
Comment 3 Karolin Seeger 2014-03-10 15:35:23 UTC
(In reply to comment #2)
> Karolin, please merge for 4.1.next.
> Thanks!

Pushed to autobuild-v4-1-test.
Comment 4 Karolin Seeger 2014-03-25 09:35:18 UTC
(In reply to comment #3)
> (In reply to comment #2)
> > Karolin, please merge for 4.1.next.
> > Thanks!
> 
> Pushed to autobuild-v4-1-test.

Pushed to v4-1-test.
Closing out bug report.

Thanks!